/*
  Copyright (c) 2012-2013 Yoshihide Yoshimoto
 */

#ifndef XTAPP_EXCHANGE_KERN_OPENCL
#define XTAPP_EXCHANGE_KERN_OPENCL

typedef struct {double re; double im;} double_complex;

void init_exchange_(int *ifgami, int *niwi, int *njwi, int* nwxi, int *nwyi, int *nwzi);

void get_exchange_nlxyz_(int *nlxo, int *nlyo, int *nlzo);

void setup_exchange_clkern_(const int *nkmesh, const double bb[3][3], const double q[3], const double *rcp, const double *rdp);

void setup_exchange_clkerns_(const int *nkmesh, const double bb[3][3], const double q[3], const double *rcp, const double *rdp);

void teardown_exchange_();

void compute_exchange_(int *miwi, int *mjwi, double_complex *wfi, double_complex *wfj, double_complex *vxp, double *wgt);

void compute_excheng_(int *miwi, int *mjwi, double_complex *wfi, double_complex *wfj, double *exeng, double *exengs, double *wgti, double *wgtj);
#endif
